import _extends from "@babel/runtime/helpers/esm/extends";
import { useState } from 'react';
export default function useLegacyState(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  var _useState = useState(initialState),
      state = _useState[0],
      setState = _useState[1];

  var setLegacyState = function setLegacyState(newState) {
    return setState(function (prevState) {
      return _extends({}, prevState, newState);
    });
  };

  return [state, setLegacyState];
}