import { useState, useEffect } from 'react';
var supportMatchMedia = typeof window !== 'undefined' && typeof window.matchMedia !== 'undefined';

function useMediaQuery(queryInput, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$defaultMatches = _ref.defaultMatches,
      defaultMatches = _ref$defaultMatches === void 0 ? false : _ref$defaultMatches;

  var query = queryInput.replace(/^@media( ?)/m, '');
  var matchMedia = supportMatchMedia ? window.matchMedia : null;

  var _useState = useState(defaultMatches),
      match = _useState[0],
      setMatch = _useState[1];

  useEffect(function () {
    var active = true;
    if (!supportMatchMedia) return;
    var queryList = matchMedia(query);

    var updateMatch = function updateMatch() {
      if (active) setMatch(queryList.matches);
    };

    updateMatch();
    queryList.addListener(updateMatch);
    return function () {
      active = false;
      queryList.removeListener(updateMatch);
    };
  }, [query, matchMedia]);
  return match;
}

export default useMediaQuery;