var _SIDES;

import { useEffect, useState } from 'react';
var ORIENTATION = {
  portrait: 'portrait',
  landscape: 'landscape'
};
var UPRIGHT = '0';
var RIGHT = '-90';
var LEFT = '90';
var SIDES = (_SIDES = {}, _SIDES[RIGHT] = 'right', _SIDES[UPRIGHT] = 'upright', _SIDES[LEFT] = 'left', _SIDES);
var isClient = typeof window !== 'undefined';

function useOrientation() {
  var _useState = useState(function () {
    return isClient && window.orientation;
  }),
      orientation = _useState[0],
      setOrientation = _useState[1];

  var hasOrientation = Boolean(orientation);
  var isPortrait = String(orientation) === UPRIGHT;
  var side = SIDES[String(orientation)];
  useEffect(function () {
    var handler = function handler() {
      return setOrientation(window.orientation);
    };

    window.addEventListener('orientationchange', handler);
    return function () {
      return window.removeEventListener('orientationchange', handler);
    };
  }, []); // For Desktop and SSR "orientation" is undefined. We use portrait by default

  return !hasOrientation || isPortrait ? {
    orientation: ORIENTATION.portrait,
    side: side
  } : {
    orientation: ORIENTATION.landscape,
    side: side
  };
}

useOrientation.displayName = 'HookUseOrientation';
export { ORIENTATION as orientations };
export default useOrientation;