import { useState } from 'react';
import useMount from '../useMount';
var AXIS_MAP = {
  Y: 'top',
  X: 'left'
};
var isClient = typeof window !== 'undefined' && window.document;
export default function useScroll(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$axis = _ref.axis,
      axis = _ref$axis === void 0 ? 'Y' : _ref$axis;

  var getBoundingClientRect = function getBoundingClientRect() {
    return isClient ? document.body.getBoundingClientRect() : 0;
  };

  var boundingKey = AXIS_MAP[axis];

  var _useState = useState({
    position: getBoundingClientRect()[boundingKey],
    scrollDirection: null
  }),
      scroll = _useState[0],
      setScroll = _useState[1];

  var onScroll = function onScroll(e) {
    var currentBounding = getBoundingClientRect();
    var currentPosition = -currentBounding[boundingKey];
    setScroll(function (_ref2) {
      var prevPosition = _ref2.position;
      return {
        position: currentPosition,
        scrollDirection: prevPosition > currentPosition ? 'DOWN' : 'UP'
      };
    });
  };

  useMount(function () {
    window.addEventListener('scroll', onScroll);
    return function () {
      window.removeEventListener('scroll', onScroll);
    };
  });
  return {
    position: Math.round(scroll.position),
    direction: scroll.scrollDirection
  };
}