import { useCallback, useEffect, useState } from 'react';
import useMount from '../useMount';
var THRESHOLDS = {
  DISTANCE: 100,
  TIME: 100
};
export default function useSwipe(ref) {
  var _useState = useState(undefined),
      start = _useState[0],
      setStart = _useState[1];

  var _useState2 = useState(false),
      capturing = _useState2[0],
      setCapturing = _useState2[1];

  var _useState3 = useState(undefined),
      end = _useState3[0],
      setEnd = _useState3[1];

  var _useState4 = useState(undefined),
      direction = _useState4[0],
      setDirection = _useState4[1];

  var onStart = function onStart(_ref) {
    var x = _ref.clientX,
        y = _ref.clientY;
    setCapturing(true);
    setDirection(undefined);
    setStart({
      x: x,
      y: y,
      time: Date.now()
    });
  };

  var onMove = useCallback(function (_ref2) {
    var x = _ref2.clientX,
        y = _ref2.clientY;
    return setEnd({
      x: x,
      y: y
    });
  }, []);
  useEffect(function () {
    var current = ref.current;

    if (current) {
      if (capturing) {
        current.addEventListener('pointermove', onMove);
      } else {
        current.removeEventListener('pointermove', onMove);
        var TIME = THRESHOLDS.TIME;
        var deltaTime = Date.now() - (start == null ? void 0 : start.time);

        if (deltaTime > TIME) {
          setEnd(undefined);
          var DISTANCE = THRESHOLDS.DISTANCE;
          var deltaX = (end == null ? void 0 : end.x) - start.x;
          var deltaY = (end == null ? void 0 : end.y) - start.y;

          if (deltaX > DISTANCE && Math.abs(deltaY) < DISTANCE) {
            setDirection('right');
          } else if (-deltaX > DISTANCE && Math.abs(deltaY) < DISTANCE) {
            setDirection('left');
          } else if (deltaY > DISTANCE && Math.abs(deltaX) < DISTANCE) {
            setDirection('down');
          } else if (-deltaY > DISTANCE && Math.abs(deltaX) < DISTANCE) {
            setDirection('up');
          } else {
            setDirection(undefined);
          }
        }
      }
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [capturing]);

  var onEnd = function onEnd() {
    return setCapturing(false);
  };

  useMount(function () {
    var current = ref.current;

    if (current) {
      current.addEventListener('pointerdown', onStart);
      current.addEventListener('pointerup', onEnd);
      current.addEventListener('pointerleave', onEnd);
      current.addEventListener('pointercancel', onEnd);
    }

    return function () {
      if (current) {
        current.removeEventListener('pointerdown', onStart);
        current.removeEventListener('pointerup', onEnd);
        current.removeEventListener('pointerleave', onEnd);
        current.removeEventListener('pointercancel', onEnd);
      }
    };
  });
  return direction;
}